#include <iostream>
#include <cmath>

using namespace std;
int nzd(int a, int b) {
    if (a == 0)
        return b;
    return nzd(b % a, a);
}

int main() {
    ios_base::sync_with_stdio(0);
    int N;
    cin >> N;
    int n, m, a, b, c, d;
    bool tren = true;
    for (int i = 0; i < N; i++) {
        cin >> n >> m;
        cin >> a >> b;
        c = abs(a - b);
        for (int j = 0; j < n-2; j++) {
            cin >> d;
            c = nzd(c, a - d);
        }
        tren = true;
        for (int z = 0; z < m; z++) {
            cin >> d;
            if (tren && abs(a-d) % c == 0) {
                tren = false;
            }
        }
        if (tren)
            cout << 1 << "\n";
        else
            cout << 0 << "\n";
    }
    return 0;
}